% Rotations.
%
% Help
%   quaternion  - Help on quaternions for the Rotations/ toolbox.
%   eulerAngles - Help on Euler angles for the Rotations/ toolbox.
%
% Conversion between rotation specifications
%   au2q        - Rotated angle and rotation axis vector to quaternion.
%   e2q         - Euler angles to quaternion conversion.
%   e2R         - Euler angles to rotation matrix.
%   q2au        - quaternion to rotated angle and rotation axis vector.
%   q2e         - Quaternion to Euler angles conversion.
%   q2eG        - Transform quaternion Gaussian to Euler Gaussian.
%   q2Q         - Quaternion to quaternion matrix conversion.
%   q2R         - Quaternion to rotation matrix conversion.
%   q2v         - Quaternion to rotation vector conversion.
%   R2e         - Rotation matrix to Euler angles conversion.
%   R2q         - rotation matrix to quaternion conversion.
%   v2au        - Rotation vector to rotation axis and angle conversion.
%   v2q         - Rotaiton vector to quaternion conversion.
%   v2R         - Rotation vector to rotation matrix conversion
%
% Other
%   flu2rdf     - Camera body to camera sensor rotation matrix.
%   q2Pi        - Pi matrix construction from quaternion.
%   q2qc        - Conjugate quaternion.
%   pi2pc       - Pi matrix to conjugated Pi matrix conversion.
%   qProd       - Quaternion product.
%   w2omega     - Skew symetric matrix OMEGA from angular rates vector W.
%   qRot        - Vector rotation via quaternion algebra.

