function Pi = pi2pc(Pi)

% PI2PC  Pi matrix to conjugated Pi matrix conversion.
%   PC = PI2PC(PI) converts the matrix
%       PI = QUAT2PI(Q)
%   into 
%       PC = QUAT2PI(QC)
%   where QC = Q2QC(Q), the conjugated quaternion.
%
% See also Q2QC, Q2PI, TOFRAME

%   Copyright 2008-2009 Joan Sola @ LAAS-CNRS.

Pi([1 3 4 5 6 8 9 10 11]) = -Pi([1 3 4 5 6 8 9 10 11]);



% ========== End of function - Start GPL license ==========


%   # START GPL LICENSE

%---------------------------------------------------------------------
%
%   This file is part of SLAMTB, a SLAM toolbox for Matlab.
%
%   SLAMTB is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   SLAMTB is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with SLAMTB.  If not, see <http://www.gnu.org/licenses/>.
%
%---------------------------------------------------------------------

%   SLAMTB is Copyright 2007,2008,2009 
%   by Joan Sola, David Marquez and Jean Marie Codol @ LAAS-CNRS.
%   See on top of this file for its particular copyright.

%   # END GPL LICENSE

