% Some mathematical functions.
%   This folder adds Jacobian support to existing Matlab functions, and
%   other functionnalities.
%
% Unit conversions
%   deg2rad              - Degrees to radians conversion.
%   rad2deg              - Radians to degrees conversion.
%
% Jacobian extensions to algebraic functions
%   crossJ               - Cross product with Jacobians output
%   dotJ                 - Dot product with Jacobian return
%   hat                  - Hat operator.
%   normAngle            - Normalize angle to (-pi .. pi] values.
%   normquat             - Normalize quaternion to unit length
%   normvec              - Normalize vector.
%
% Functions on Gaussian data
%   mahalanobis          - Mahalanobis distance
%   propagateUncertainty - Non-linear propagation of Gaussian uncertainty.
%   nees                 - Normalized Estimation Error Squared.
