function [ A ] = makeAnglehistogram( Scan, Yaw )
%MAKEANGLEHISTOGRAM Generates the Angle histogram of global orientations of 
%the the vectors generated by consecutive points.

angleres = 0.0175;
angles=zeros(size(Scan,1)-1,1);
    for k=1:size(Scan,1)-1
       angles(k) = normAngle(atan2(Scan(k,1) - Scan(k+1,1),Scan(k,2) - Scan(k+1,2)) + Yaw);
    end
    
    A = zeros(1,round((2*pi)/angleres)+ 1 ) ;
    
    for k = 1:size(angles,1)
        j = round(angles(k) / angleres) + 1 + round((pi)/angleres);
        j = min(j,size(A,2));
        A(j) = A(j) + 1;
    end
end

